"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const common_1 = require("@nestjs/common");
const core_1 = require("@nestjs/core");
const terminus_1 = require("@godaddy/terminus");
const terminus_2 = require("@nestjs/terminus");
const utils_1 = require("@nestjs/terminus/dist/utils");
const elasticsearch_1 = require("@nestjs/elasticsearch");
let ElasticSearchHealthIndicator = class ElasticSearchHealthIndicator extends terminus_2.HealthIndicator {
    constructor(moduleRef) {
        super();
        this.moduleRef = moduleRef;
        this.checkDependantPackages();
    }
    checkDependantPackages() {
        utils_1.checkPackages(['@nestjs/elasticsearch'], this.constructor.name);
    }
    getContextService() {
        try {
            return this.moduleRef.get(elasticsearch_1.ElasticsearchService, {
                strict: false,
            });
        }
        catch (err) {
            return null;
        }
    }
    pingCheck(key) {
        return __awaiter(this, void 0, void 0, function* () {
            let isHealthy = false;
            this.checkDependantPackages();
            const client = this.getContextService();
            if (!client) {
                throw new terminus_1.HealthCheckError(`${key} is not available`, this.getStatus(key, isHealthy, {
                    message: 'ElasticSearch service not found in application context',
                }));
            }
            try {
                const [result] = yield client.ping({}).toPromise();
                isHealthy = result;
            }
            catch (error) {
                isHealthy = false;
            }
            if (isHealthy) {
                return this.getStatus(key, isHealthy);
            }
            else {
                throw new terminus_1.HealthCheckError(`${key} is not available`, this.getStatus(key, isHealthy));
            }
        });
    }
};
ElasticSearchHealthIndicator = __decorate([
    common_1.Injectable({ scope: common_1.Scope.TRANSIENT }),
    __metadata("design:paramtypes", [core_1.ModuleRef])
], ElasticSearchHealthIndicator);
exports.ElasticSearchHealthIndicator = ElasticSearchHealthIndicator;
